<?php

	if(!defined('DOKU_INC')) define('DOKU_INC',realpath(dirname(__FILE__).'/../../').'/');
	if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
	require_once(DOKU_PLUGIN.'admin.php');
	
	require_once(DOKU_PLUGIN.'sync/DifferenceEngine.php');
	
	require_once(DOKU_INC.'inc/common.php');
	require_once(DOKU_INC.'inc/changelog.php');
	require_once(DOKU_INC.'inc/actions.php');
	
	require_once(DOKU_PLUGIN.'sync/index.php');
	
	class admin_plugin_sync extends DokuWiki_Admin_Plugin
	{
		private $server; // serwer
		private $user; // uzytkownik
		private $password; // haslo
		private $path; // sciezka do wiki
		
		private $conflicts; // tablica plikow z konfliktami
		private $updates; // tablica zsynchronizowanych plikow
		
		private $diffPart; // zawiera pociete diffy
		
		private $debug = true;
		
		// ustawienia serwera
		public function __construct()
		{
			$this->server = $this->getConf('server');
			$this->user = $this->getConf('user');
			$this->password = $this->getConf('password');
			$this->path = $this->getConf('path');
		}
		
		// informacje o pluginie
		function getInfo()
		{
			return array(
				'author' => 'Sebastian Pracuch',
				'email'  => 'sebastian@pracuch.pl',
				'date'   => '2009-04-01',
				'name'   => 'Synchronizacja',
			);
		}
		
		// pozycja w menu
		function getMenuSort()
		{
			return 1;
		}		
		
		// sprawdza polaczenie z serwerem
		function testServer()
		{	
			if($this->debug)
			{
				echo '<div style="width:100%; padding: 10px; margin: 1px; font-size: 14px; text-align: left; color: #555; background-color: #DDD">';
				echo '<b>Test połączenia z serwerem:</b>';
			}
		
			// zmienna HOME okresla miejsce, w ktorym beda znajdowac sie logi uniosona
			$cmd = 'export HOME="'.DOKU_PLUGIN.'sync/unison"; '.
				   'expect '.DOKU_PLUGIN.'sync/script/testServer.sh '.$this->server.' '.$this->user.' '.$this->password.' '.$this->path.' '.DOKU_INC;			
			
			$descriptorspec = array(				
				0 => array("pipe", "r"),
				1 => array("pipe", "w"),
				2 => array("pipe", "w")			
			);
			
			$cwd = DOKU_PLUGIN.'sync/unison/';
			
			$process = proc_open($cmd, $descriptorspec, $pipes, $cwd);
			
			if(is_resource($process))
			{	
				// pobranie bledow
				$result = stream_get_contents($pipes[2]);
				fclose($pipes[2]);
			}
			
			$return_value = proc_close($process);
			
			// brak polaczenia jesli wystapily bledy
			if(strlen($result) > 0)
			{
				if($this->debug)
				{
					echo '<font color="red"> ERROR</font>';
					echo '<br/>';
					echo '</div>';
				}
				return false;
			}
			else
			{
				if($this->debug)
				{
					echo '<font color="green"> OK</font>';
					echo '<br/>';
					echo '</div>';
				}
				return true;
			}
		}
		
		// sprawdza czy podana sciezka istnieje
		function testServerPath()
		{	
			if($this->debug)
			{
				echo '<div style="width:100%; padding: 10px; margin: 1px; font-size: 14px; text-align: left; color: #555; background-color: #DDD">';
				echo '<b>Test ścieżki do dokuwiki na serwerze:</b>';
			}
		
			$cmd = 'expect '.DOKU_PLUGIN.'sync/script/testServerPath.sh '.$this->server.' '.$this->user.' '.$this->password.' '.$this->path.' '.DOKU_INC.'/data/pages';			
			
			$descriptorspec = array(				
				0 => array("pipe", "r"),
				1 => array("pipe", "w"),
				2 => array("pipe", "w")			
			);
			
			$cwd = DOKU_PLUGIN.'sync/unison/';
			
			$process = proc_open($cmd, $descriptorspec, $pipes, $cwd);
			
			if(is_resource($process))
			{	
				// pobranie bledow
				$result = stream_get_contents($pipes[2]);
				fclose($pipes[2]);
			}
			
			$return_value = proc_close($process);
			
			// bledna sciezka jesli wystapily bledy		
			if(strlen($result) > 0)
			{
				if($this->debug)
				{
					echo '<font color="red"> ERROR</font>';
					echo '<br/>';
					echo '</div>';
				}
				return false;
			}
			else
			{
				if($this->debug)
				{
					echo '<font color="green"> OK</font>';
					echo '<br/>';
					echo '</div>';
				}
				return true;
			}
		}
		
		// synchronizuje pliki
		function synchronize($path)
		{		
			if($this->debug)
			{
				echo '<div style="width:100%; padding: 10px; margin: 1px; font-size: 14px; text-align: left; color: #555; background-color: #DDD">';
				echo '<b>Test synchronizacji';
				if(strcmp($path,'') == 0)
					echo ': </b>';
				else
					echo ' "'.$path.'": </b>';
			}
		
			// zmienna HOME okresla miejsce, w ktorym beda znajdowac sie logi uniosona
			$cmd = 'export HOME="'.DOKU_PLUGIN.'sync/unison"; '.
				   'expect '.DOKU_PLUGIN.'sync/script/synchronize.sh '.$this->server.' '.$this->user.' '.$this->password.' '.$this->path.' '.DOKU_INC.' /'.$path;			
			
			$descriptorspec = array(
				0 => array("pipe", "r"),
				1 => array("pipe", "w"),
				2 => array("pipe", "w")				
			);
			
			$cwd = DOKU_PLUGIN.'sync/unison/';
			
			$process = proc_open($cmd, $descriptorspec, $pipes, $cwd);
			
			if(is_resource($process))
			{				
				// pobranie wyniku
				$result = stream_get_contents($pipes[1]);
				fclose($pipes[1]);
				
				// pobranie bledow
				$error = stream_get_contents($pipes[2]);
				fclose($pipes[2]);
			}
			
			if($this->debug)
			{	
				if(strcmp($error,'directory') == 0)
				{
						echo '<font color="red"> ERROR</font>';
						echo '<br/>';
						
						return false;
				}
				else
				{
						echo '<font color="green"> OK</font>';
						echo '<br/>';
				}
			}
			
			if($this->debug)
			{
				echo '</div>';
			}
			
			$return_value = proc_close($process);
			
			$tab = explode("\n", $result);
				
			// analiza 
			$this->conflicts = array();
			$this->updates = array();
			
			for($i=0; $i<count($tab); $i++)
			{							
				if(ereg("<-\?->", $tab[$i]))
				{				
					$line = explode(" ", trim($tab[$i]));
					if(strcmp(substr($line[count($line)-1],-4),'.txt') == 0)
					{
						array_push($this->conflicts,$line[count($line)-1]);
					
						if($this->debug)
						{						
							echo '<div style="width:100%; padding: 10px; margin: 1px; font-size: 14px; text-align: left; color: #555; background-color: #DDD">';
							echo '<font color="red">CONFLICT:</font>';
							echo ' <b>"'.$line[count($line)-1].'":</b>';							
							echo '</div>';
						}
					}
				}
				
				if(ereg("BGN", $tab[$i]))
				{
					$line = explode(" ", trim($tab[$i]));
					array_push($this->updates,$line[count($line)-1]);
					
					if($this->debug)
					{						
						echo '<div style="width:100%; padding: 10px; margin: 1px; font-size: 14px; text-align: left; color: #555; background-color: #DDD">';
												
						if(ereg("Deleting", $tab[$i]))
						{
							echo '<font color="green">DELETING: </font>';
						}
						else
						{
							if(strcmp(trim($tab[$i+1]).'/','from '.DOKU_INC) == 0)
								echo '<font color="green">UPDATING [SERWER]: </font>';
							else
								echo '<font color="green">UPDATING [LOCALHOST]: </font>';
						}
						
						echo ' <b>"'.$line[count($line)-1].'"</b>';
						
						echo '</div>';
					}
				}
			}	
						
			// rozwiazywanie konfliktow - lokalne pliki do REV
			if(count($this->conflicts) > 0)			
			{
				for($i=0; $i<count($this->conflicts); $i++)
				{
					$line = explode("/", trim($this->conflicts[$i]));
					if(count($line) >= 3)
					{
						if(strcmp($line[0],'data') == 0 and strcmp($line[1],'pages') == 0)
						{
							global $ID;
							global $TEXT;
							
							$id = substr($this->conflicts[$i],11);
							$id = substr($id,0,strlen($id)-4);
							$ID = str_replace('/',':',$id);
							$TEXT = ' ';
							
							act_save('save');
						}
					}
				}
			}
			
			// wykryte konflikty zostaja zlikwidowane - pliki zostaja pobrane z serwera
			if(count($this->conflicts) > 0)
			{
				for($i=0; $i<count($this->conflicts); $i++)
				{
					$path = trim($this->conflicts[$i]);
					$this->copyFromServer($path);					
				}
			}			
			
			return true;
		}
		
		// kopiuje plik z serwera
		function copyFromServer($path)
		{		
			$cmd = 'expect '.DOKU_PLUGIN.'sync/script/copyFromServer.sh '.$this->server.' '.$this->user.' '.$this->password.' '.$this->path.' '.DOKU_INC.' '.$path;			
			
			$descriptorspec = array(
				0 => array("pipe", "r"),
				1 => array("pipe", "w"),
				2 => array("pipe", "w")				
			);
			
			$cwd = DOKU_PLUGIN.'sync/unison/';
			
			$process = proc_open($cmd, $descriptorspec, $pipes, $cwd);
			
			if(is_resource($process))
			{						
				$result = stream_get_contents($pipes[1]);
				fclose($pipes[1]);
			}
			
			$return_value = proc_close($process);
			
			$tab = explode("\n", $result);
			return $tab;
		}
		
		// kopiuje pliki na server
		function copyToServer($path)
		{		
			$path = str_replace(':','/',$path);
			
			$cmd = 'expect '.DOKU_PLUGIN.'sync/script/copyToServer.sh '.$this->server.' '.$this->user.' '.$this->password.' '.$this->path.' '.DOKU_INC.' '.$path;
			
			$descriptorspec = array(
				0 => array("pipe", "r"),
				1 => array("pipe", "w"),
				2 => array("pipe", "w")				
			);
			
			$cwd = DOKU_PLUGIN.'sync/unison/';
			
			$process = proc_open($cmd, $descriptorspec, $pipes, $cwd);
			
			if(is_resource($process))
			{						
				$result = stream_get_contents($pipes[1]);
				fclose($pipes[1]);
			}
			
			$return_value = proc_close($process);
						
			$tab = explode("\n", $result);
			return $tab;
		}
		
		function patch()
		{
			$id = ''; 
			$patch = array();			
				
			foreach ($_POST as $key => $value)
			{
				if(strcmp($key,'synchronizacja2') != 0)
				{
					$end = substr($key,-2);
					
					if(strcmp($end,'_1') == 0)
					{
						$id = substr($key,0,-2);
						
						// porownaj obecna i poprzednia
						$l_rev = '';
						$revs = getRevisions($id, 0, 1);
						$r_rev = $revs[0];
						
						$l_text = rawWiki($id,$l_rev);
						$r_text = rawWiki($id,$r_rev);
						
						// diff
						$df = new Diff(explode("\n",htmlspecialchars($l_text)),
									   explode("\n",htmlspecialchars($r_text)));
									   
						$udf = new UnifiedDiffFormatter();
						$diff = $udf->format($df);
						
						$lines = explode("\n", $diff);
						
						$index = 0;
						$name = 'trash';
						$this->diffPart[$name] = array();
						for($i=0; $i<count($lines); $i++)
						{
							if(ereg("@@", $lines[$i]))
							{
								$name = $id.'_'.++$index;
								$this->diffPart[$name] = array();
							}
							array_push($this->diffPart[$name],$lines[$i]);				
						}
						$name = 'trash';
						unset($this->diffPart[$name]);
												
						$patch[$id] = array();
					}
					
					if(strcmp($value,'local') == 0)
					{
						for($i=0; $i<count($this->diffPart[$key]); $i++)
						{
							array_push($patch[$id],$this->diffPart[$key][$i]);
						}
					}
				}
			}
			
			return $patch;		
		}
				
		function saveFile($path,$text)
		{			
			$cmd = 'cat > '.$path;
			
			$descriptorspec = array(
				0 => array("pipe", "r"),
				1 => array("pipe", "w"),
				2 => array("pipe", "w")				
			);
			
			$cwd = DOKU_PLUGIN.'sync/unison/';
			
			$process = proc_open($cmd, $descriptorspec, $pipes, $cwd);
			
			if(is_resource($process))
			{
				// orginal
				fwrite($pipes[0], '--- server');
				fwrite($pipes[0], chr(10));		
				
				// new
				fwrite($pipes[0], '+++ local');
				fwrite($pipes[0], chr(10));
			
				for($i=0; $i<count($text)-1; $i++)
				{					
					fwrite($pipes[0], $text[$i]);
					fwrite($pipes[0], chr(10));
				}
				
    			fclose($pipes[0]);
			}
			
			$return_value = proc_close($process);
		}
		
		function update($id,$patch)
		{			
			$file = str_replace(':','/',$id);
		
			$cmd = 'patch '.$file.'.txt < '.$patch;
			
			$descriptorspec = array(
				0 => array("pipe", "r"),
				1 => array("pipe", "w"),
				2 => array("pipe", "w")				
			);
			
			$cwd = DOKU_PLUGIN.'sync/unison/';
			
			$process = proc_open($cmd, $descriptorspec, $pipes, $cwd);			
			$return_value = proc_close($process);
			
			if($this->debug)
			{
				echo '<div style="width:100%; padding: 10px; margin: 1px; font-size: 14px; text-align: left; color: #555; background-color: #DDD">';
				echo '<b>"'.$file.'":</b>';
				echo '<font color="green"> SYNCHRONIZACJA</font>';
				echo '</div>';
			}	
		}
		
		function deleteFile($path)
		{
			exec('rm '.$path);
		}
				
		function handle()
		{			
		}
		
		function html()
		{
			// sprawdzenie polaczenia z serwerem
			if($this->testServer())
			{
				// sprawdzenie ustawionej sciezki na serwerze
				if($this->testServerPath())
				{
					// etap 1
					if(!$_POST)
					{										
						// wyswietlenie drzewa synchronizacji
						echo '<h1>Dokonaj synchronizacji:';
						echo '</h1>';
						
						echo '<strong><form method="post" action=""><input type="hidden" name="synchronizacja">';
						echo '<input type="hidden" name="path" value="">';
						echo '<input type="submit" value="S"></form> DOKUWIKI</strong>';
						
						my_html_index();
					}
					
					// etap 2
					if($_POST)
					{				
						if(isset($_POST['synchronizacja']))
						{							
							// synchronizacja wybranej sciezki
							$this->synchronize($_POST['path']);
							
							if(count($this->conflicts)>0)
							{							
								// wyswietlenie drzewa synchronizacji
								echo '<h1>Rozwiąż konflikty:</h1>';
								my_html_show_synchronization($this->conflicts,$_POST['path']);
							}
						}
					}
					
					// etap 3
					if($_POST)
					{				
						if(isset($_POST['synchronizacja2']))
						{
							$patch = $this->patch();
							foreach ($patch as $key => $value)
							{												
								$this->saveFile(DOKU_PLUGIN.'sync/diff/'.$key,$value);
								$this->update(DOKU_INC.'/data/pages/'.$key,DOKU_PLUGIN.'sync/diff/'.$key);
								$this->copyToServer('data/pages/'.$key.'.txt');
								$this->deleteFile(DOKU_PLUGIN.'sync/diff/'.$key);
							}		
							
						}
					}
				}
			}
		}	
	}	
?>